package com.xmomen.module.system.entity;

import com.xmomen.framework.mybatis.model.BaseMybatisExample;
import java.util.ArrayList;
import java.util.List;

// 系统字典实体类
public class SysDictionaryExample extends BaseMybatisExample {
    // 排序字段
    protected String orderByClause;

    // 是否去重
    protected boolean distinct;

    // 查询条件
    protected List<Criteria> oredCriteria;

    // 构造函数
    public SysDictionaryExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    // 设置排序字段
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    // 获取排序字段
    public String getOrderByClause() {
        return orderByClause;
    }

    // 设置是否去重
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    // 获取是否去重
    public boolean isDistinct() {
        return distinct;
    }

    // 获取查询条件
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    // 添加查询条件
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    // 创建查询条件
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    // 创建查询条件
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    // 创建查询条件
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    // 清空查询条件
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    // 生成查询条件
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        // 判断查询条件是否有效
        public boolean isValid() {
            return criteria.size() > 0;
        }

        // 获取所有查询条件
        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        // 获取查询条件
        public List<Criterion> getCriteria() {
            return criteria;
        }

        // 添加查询条件
        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        // 添加查询条件
        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        // 添加查询条件
        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        // 添加查询条件
        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeIsNull() {
            addCriterion("DICTIONARY_CODE is null");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeIsNotNull() {
            addCriterion("DICTIONARY_CODE is not null");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeEqualTo(String value) {
            addCriterion("DICTIONARY_CODE =", value, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeNotEqualTo(String value) {
            addCriterion("DICTIONARY_CODE <>", value, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeGreaterThan(String value) {
            addCriterion("DICTIONARY_CODE >", value, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeGreaterThanOrEqualTo(String value) {
            addCriterion("DICTIONARY_CODE >=", value, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeLessThan(String value) {
            addCriterion("DICTIONARY_CODE <", value, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeLessThanOrEqualTo(String value) {
            addCriterion("DICTIONARY_CODE <=", value, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeLike(String value) {
            addCriterion("DICTIONARY_CODE like", value, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeNotLike(String value) {
            addCriterion("DICTIONARY_CODE not like", value, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeIn(List<String> values) {
            addCriterion("DICTIONARY_CODE in", values, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeNotIn(List<String> values) {
            addCriterion("DICTIONARY_CODE not in", values, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeBetween(String value1, String value2) {
            addCriterion("DICTIONARY_CODE between", value1, value2, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryCodeNotBetween(String value1, String value2) {
            addCriterion("DICTIONARY_CODE not between", value1, value2, "dictionaryCode");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescIsNull() {
            addCriterion("DICTIONARY_DESC is null");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescIsNotNull() {
            addCriterion("DICTIONARY_DESC is not null");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescEqualTo(String value) {
            addCriterion("DICTIONARY_DESC =", value, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescNotEqualTo(String value) {
            addCriterion("DICTIONARY_DESC <>", value, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescGreaterThan(String value) {
            addCriterion("DICTIONARY_DESC >", value, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescGreaterThanOrEqualTo(String value) {
            addCriterion("DICTIONARY_DESC >=", value, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescLessThan(String value) {
            addCriterion("DICTIONARY_DESC <", value, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescLessThanOrEqualTo(String value) {
            addCriterion("DICTIONARY_DESC <=", value, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescLike(String value) {
            // 添加查询条件，查询字典描述字段中包含指定值的记录
            addCriterion("DICTIONARY_DESC like", value, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescNotLike(String value) {
            addCriterion("DICTIONARY_DESC not like", value, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescIn(List<String> values) {
            addCriterion("DICTIONARY_DESC in", values, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andDictionaryDescNotIn(List<String> values) {
            // 添加查询条件，字段为DICTIONARY_DESC，条件为not in，值为values，字段名为dictionaryDesc
            addCriterion("DICTIONARY_DESC not in", values, "dictionaryDesc");
            return (Criteria) this;
        }

        // 添加查询条件
        // 添加一个条件，字典描述在value1和value2之间
        public Criteria andDictionaryDescBetween(String value1, String value2) {
            // 添加条件
            addCriterion("DICTIONARY_DESC between", value1, value2, "dictionaryDesc");
            // 返回当前对象
            return (Criteria) this;
        }

        // 添加查询条件
        // 添加一个条件，字典描述不在value1和value2之间
        public Criteria andDictionaryDescNotBetween(String value1, String value2) {
            // 添加条件
            addCriterion("DICTIONARY_DESC not between", value1, value2, "dictionaryDesc");
            // 返回当前对象
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andAvailableIsNull() {
            addCriterion("AVAILABLE is null");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andAvailableIsNotNull() {
            addCriterion("AVAILABLE is not null");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andAvailableEqualTo(Integer value) {
            addCriterion("AVAILABLE =", value, "available");
            return (Criteria) this;
        }

        // 添加查询条件
        // 添加一个条件，AVAILABLE不等于value
        public Criteria andAvailableNotEqualTo(Integer value) {
            addCriterion("AVAILABLE <>", value, "available");
            return (Criteria) this;
        }

        // 添加查询条件
        // 添加一个条件，AVAILABLE字段的值大于value
        public Criteria andAvailableGreaterThan(Integer value) {
            addCriterion("AVAILABLE >", value, "available");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andAvailableGreaterThanOrEqualTo(Integer value) {
            addCriterion("AVAILABLE >=", value, "available");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andAvailableLessThan(Integer value) {
            addCriterion("AVAILABLE <", value, "available");
            return (Criteria) this;
        }

        // 添加查询条件
        // 添加一个条件，AVAILABLE字段小于等于value
        public Criteria andAvailableLessThanOrEqualTo(Integer value) {
            // 添加查询条件，AVAILABLE字段小于等于value
            addCriterion("AVAILABLE <=", value, "available");
            return (Criteria) this;
        }

        // 添加查询条件
        public Criteria andAvailableIn(List<Integer> values) {
            // 添加查询条件，AVAILABLE字段在values列表中
            addCriterion("AVAILABLE in", values, "available");
            return (Criteria) this;
        }

        // 添加查询条件
        // 根据传入的值，添加一个条件，表示AVAILABLE字段不在传入的值列表中
        public Criteria andAvailableNotIn(List<Integer> values) {
            addCriterion("AVAILABLE not in", values, "available");
            return (Criteria) this;
        }

        // 添加查询条件
        // 添加一个条件，AVAILABLE字段在value1和value2之间
        public Criteria andAvailableBetween(Integer value1, Integer value2) {
            addCriterion("AVAILABLE between", value1, value2, "available");
            return (Criteria) this;
        }

        // 添加查询条件
        // 添加一个条件，AVAILABLE字段的值不在value1和value2之间
        // 添加一个条件，AVAILABLE字段的值不在value1和value2之间
        public Criteria andAvailableNotBetween(Integer value1, Integer value2) {
            // 调用addCriterion方法，添加条件
            addCriterion("AVAILABLE not between", value1, value2, "available");
            // 返回当前Criteria对象
            return (Criteria) this;
        }
    }

    // 查询条件
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    // 查询条件
    public static class Criterion {
        private String condition;

        // 值
        private Object value;

        // 第二个值
        private Object secondValue;

        // 没有值
        private boolean noValue;

        // 单个值
        private boolean singleValue;

        // 两个值之间的值
        private boolean betweenValue;

        // 列表值
        private boolean listValue;

        // 类型处理器
        private String typeHandler;

        // 获取查询条件
        public String getCondition() {
            return condition;
        }

        // 获取查询条件
        public Object getValue() {
            return value;
        }

        // 获取查询条件
        public Object getSecondValue() {
            return secondValue;
        }

        // 判断查询条件是否为空
        public boolean isNoValue() {
            return noValue;
        }

        // 判断查询条件是否为单个值
        public boolean isSingleValue() {
            return singleValue;
        }

        // 判断查询条件是否为范围值
        public boolean isBetweenValue() {
            return betweenValue;
        }

        // 判断查询条件是否为列表值
        public boolean isListValue() {
            return listValue;
        }

        // 获取查询条件
        public String getTypeHandler() {
            return typeHandler;
        }

        // 构造函数
        protected Criterion(String condition) {
            super();
            // 设置条件
            this.condition = condition;
            // 设置类型处理器
            this.typeHandler = null;
            // 设置无值
            this.noValue = true;
        }

        // 构造函数
        // 构造函数，用于创建Criterion对象
        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            // 设置条件
            this.condition = condition;
            // 设置值
            this.value = value;
            // 设置类型处理器
            this.typeHandler = typeHandler;
            // 判断值是否为List类型
            if (value instanceof List<?>) {
                // 如果是List类型，则设置listValue为true
                this.listValue = true;
            } else {
                // 否则，设置singleValue为true
                this.singleValue = true;
            }
        }

        // 构造函数
        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

            // 调用父类的构造方法
            // 设置条件
        // 构造函数
            // 设置值
        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            // 设置第二个值
            super();
            // 设置类型处理器
            this.condition = condition;
            // 设置betweenValue为true
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        // 构造函数，传入条件、值、第二个值
        // 构造函数
            // 调用另一个构造函数，传入条件、值、第二个值和null
        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}